package cn.ibizlab.core.sample.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.HashMap;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.core.sample.domain.IBIZSample0013;
import cn.ibizlab.core.sample.filter.IBIZSample0013SearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.alibaba.fastjson.JSONObject;

public interface IBIZSample0013Mapper extends BaseMapper<IBIZSample0013> {

    Page<IBIZSample0013> searchDefault(IPage page, @Param("srf") IBIZSample0013SearchContext context, @Param("ew") Wrapper<IBIZSample0013> wrapper);
    @Override
    IBIZSample0013 selectById(Serializable id);
    @Override
    int insert(IBIZSample0013 entity);
    @Override
    int updateById(@Param(Constants.ENTITY) IBIZSample0013 entity);
    @Override
    int update(@Param(Constants.ENTITY) IBIZSample0013 entity, @Param("ew") Wrapper<IBIZSample0013> updateWrapper);
    @Override
    int deleteById(Serializable id);
    /**
    * 自定义查询SQL
    * @param sql
    * @return
    */
    @Select("${sql}")
    List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);

    List<IBIZSample0013> selectByIbizsample0012id(@Param("ibizsample0012id") Serializable ibizsample0012id);

    List<IBIZSample0013> selectByIbizuniproductid(@Param("ibizuniproductid") Serializable ibizuniproductid);

}
