package cn.ibizlab.core.sample.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.core.sample.domain.IBIZCustom;
import cn.ibizlab.core.sample.filter.IBIZCustomSearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[IBIZCustom] 服务对象接口
 */
public interface IIBIZCustomService extends IService<IBIZCustom> {

    boolean create(IBIZCustom et);
    void createBatch(List<IBIZCustom> list);
    boolean update(IBIZCustom et);
    void updateBatch(List<IBIZCustom> list);
    boolean remove(String key);
    void removeBatch(Collection<String> idList);
    IBIZCustom get(String key);
    IBIZCustom getDraft(IBIZCustom et);
    boolean checkKey(IBIZCustom et);
    boolean save(IBIZCustom et);
    void saveBatch(List<IBIZCustom> list);
    Page<IBIZCustom> searchDefault(IBIZCustomSearchContext context);
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<IBIZCustom> getIbizcustomByIds(List<String> ids);
    List<IBIZCustom> getIbizcustomByEntities(List<IBIZCustom> entities);
}


