package cn.ibizlab.core.sample.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.core.sample.domain.IBIZSample0012;
import cn.ibizlab.core.sample.filter.IBIZSample0012SearchContext;
import cn.ibizlab.core.sample.service.IIBIZSample0012Service;

import cn.ibizlab.util.helper.CachedBeanCopier;
import cn.ibizlab.util.helper.DEFieldCacheMap;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.ibizlab.core.sample.mapper.IBIZSample0012Mapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.alibaba.fastjson.JSONObject;
import org.springframework.util.StringUtils;

/**
 * 实体[订单] 服务对象接口实现
 */
@Slf4j
@Service("IBIZSample0012ServiceImpl")
public class IBIZSample0012ServiceImpl extends ServiceImpl<IBIZSample0012Mapper, IBIZSample0012> implements IIBIZSample0012Service {

    @Autowired
    @Lazy
    protected cn.ibizlab.core.sample.service.IIBIZSample0013Service ibizsample0013Service;

    protected int batchSize = 500;

    @Override
    @Transactional
    public boolean create(IBIZSample0012 et) {
        if(!this.retBool(this.baseMapper.insert(et))) {
            return false;
        }
        CachedBeanCopier.copy(get(et.getIbizsample0012id()), et);
        return true;
    }

    @Override
    @Transactional
    public void createBatch(List<IBIZSample0012> list) {
        this.saveBatch(list, batchSize);
    }

    @Override
    @Transactional
    public boolean update(IBIZSample0012 et) {
        if(!update(et, (Wrapper) et.getUpdateWrapper(true).eq("ibizsample0012id", et.getIbizsample0012id()))) {
            return false;
        }
        CachedBeanCopier.copy(get(et.getIbizsample0012id()), et);
        return true;
    }

    @Override
    @Transactional
    public void updateBatch(List<IBIZSample0012> list) {
        updateBatchById(list, batchSize);
    }

    @Override
    @Transactional
    public boolean remove(String key) {
        ibizsample0013Service.resetByIbizsample0012id(key);
        boolean result = removeById(key);
        return result ;
    }

    @Override
    @Transactional
    public void removeBatch(Collection<String> idList) {
        ibizsample0013Service.resetByIbizsample0012id(idList);
        removeByIds(idList);
    }

    @Override
    @Transactional
    public IBIZSample0012 get(String key) {
        IBIZSample0012 et = getById(key);
        if(et == null){
            et = new IBIZSample0012();
            et.setIbizsample0012id(key);
        }
        else {
        }
        return et;
    }

    @Override
    public IBIZSample0012 getDraft(IBIZSample0012 et) {
        return et;
    }

    @Override
    public boolean checkKey(IBIZSample0012 et) {
        return (!ObjectUtils.isEmpty(et.getIbizsample0012id())) && (!Objects.isNull(this.getById(et.getIbizsample0012id())));
    }
    @Override
    @Transactional
    public boolean save(IBIZSample0012 et) {
        if(!saveOrUpdate(et)) {
            return false;
        }
        return true;
    }

    @Override
    @Transactional
    public boolean saveOrUpdate(IBIZSample0012 et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? this.update(et) : this.create(et);
        }
    }

    @Override
    @Transactional
    public boolean saveBatch(Collection<IBIZSample0012> list) {
        saveOrUpdateBatch(list,batchSize);
        return true;
    }

    @Override
    @Transactional
    public void saveBatch(List<IBIZSample0012> list) {
        saveOrUpdateBatch(list,batchSize);
    }



    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<IBIZSample0012> searchDefault(IBIZSample0012SearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<IBIZSample0012> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
        return new PageImpl<IBIZSample0012>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }







    @Override
    public List<JSONObject> select(String sql, Map param){
        return this.baseMapper.selectBySQL(sql,param);
    }

    @Override
    @Transactional
    public boolean execute(String sql , Map param){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql,param);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

    @Override
    public List<IBIZSample0012> getIbizsample0012ByIds(List<String> ids) {
         return this.listByIds(ids);
    }

    @Override
    public List<IBIZSample0012> getIbizsample0012ByEntities(List<IBIZSample0012> entities) {
        List ids =new ArrayList();
        for(IBIZSample0012 entity : entities){
            Serializable id=entity.getIbizsample0012id();
            if(!ObjectUtils.isEmpty(id)){
                ids.add(id);
            }
        }
        if(ids.size()>0) {
            return this.listByIds(ids);
        }
        else {
            return entities;
        }
    }




    /**
     * 获取searchContext
     * @return
     */
    public IBIZSample0012SearchContext getSearchContext(){
        return new IBIZSample0012SearchContext();
    }
}



